// ===================================================================
// Wiilib library for Puredata
// contains the following externals:
// wiimote: the main external for working with a wii
// wiibuttons: an easier way to handle button information
// wiiAcc: a wrapper for accelerometer information
//
// Written by Yvan Vander Sanden (Jan 2008), http://youngmusic.org
// Parts written by Mike Wozniewki (Feb 2007), www.mikewoz.com
//
// Requires the CWiid library (version 0.6.00) by L. Donnie Smith
//
// ===================================================================
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
// ===================================================================
//

#include <m_pd.h>
#include <glib.h>
#include <cwiid.h>

#include "wiimote.h"
#include "wiibuttons.h"
#include "wiiAcc.h"

static t_class *c_wiilib;

typedef struct _wiilib {
	t_object object;
} type_wiilib;

static void *new_wiilib(void) {
	type_wiilib * x = (type_wiilib *)pd_new(c_wiilib);
	return (x);
}

void wiilib_setup(void) {
	c_wiilib = class_new(gensym("wiilib"), new_wiilib, 0, sizeof(t_object), CLASS_NOINLET, 0);

	// needed for a callback function in wiimote.c
	// in depth explained there
	//
	setup = 0;
	wiimote_setup();
	wiibuttons_setup();
	wiiAcc_setup();
	wiiIR_setup();
	post("wiilib library loaded! (GPLed Yvan Vander Sanden january 2008)");
}
